clang 8.0.0

Classes | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
clang::comments::BlockCommandComment Class Reference

A command that has zero or more word-like arguments (number of word-like arguments depends on command name) and a paragraph as an argument (e. More...

`#include "clang/AST/Comment.h"`

Inheritance diagram for clang::comments::BlockCommandComment:
[legend]
Collaboration diagram for clang::comments::BlockCommandComment:
[legend]

## Classes
struct | Argument

## Public Member Functions
| BlockCommandComment (SourceLocation LocBegin, SourceLocation LocEnd, unsigned CommandID, CommandMarkerKind CommandMarker)
child_iterator | child_begin () const
child_iterator | child_end () const
unsigned | getCommandID () const
StringRef | getCommandName (const CommandTraits &Traits) const
SourceLocation | getCommandNameBeginLoc () const
SourceRange | getCommandNameRange (const CommandTraits &Traits) const
unsigned | getNumArgs () const
StringRef | getArgText (unsigned Idx) const
SourceRange | getArgRange (unsigned Idx) const
void | setArgs (ArrayRef< Argument > A)
ParagraphComment * | getParagraph () const LLVM_READONLY
bool | hasNonWhitespaceParagraph () const
void | setParagraph (ParagraphComment *PC)
CommandMarkerKind | getCommandMarker () const LLVM_READONLY
Public Member Functions inherited from clang::comments::Comment
| Comment (CommentKind K, SourceLocation LocBegin, SourceLocation LocEnd)
CommentKind | getCommentKind () const
const char * | getCommentKindName () const
void | dump () const
void | dumpColor () const
void | dump (const ASTContext &Context) const
void | dump (raw_ostream &OS, const CommandTraits *Traits, const SourceManager *SM) const
SourceRange | getSourceRange () const LLVM_READONLY
SourceLocation | getBeginLoc () const LLVM_READONLY
SourceLocation | getEndLoc () const LLVM_READONLY
SourceLocation | getLocation () const LLVM_READONLY
child_iterator | child_begin () const
child_iterator | child_end () const
unsigned | child_count () const

## Static Public Member Functions
static bool | classof (const Comment *C)
Static Public Member Functions inherited from clang::comments::BlockContentComment
static bool | classof (const Comment *C)

## Protected Member Functions
| BlockCommandComment (CommentKind K, SourceLocation LocBegin, SourceLocation LocEnd, unsigned CommandID, CommandMarkerKind CommandMarker)
Protected Member Functions inherited from clang::comments::BlockContentComment
| BlockContentComment (CommentKind K, SourceLocation LocBegin, SourceLocation LocEnd)
Protected Member Functions inherited from clang::comments::Comment
void | setSourceRange (SourceRange SR)
void | setLocation (SourceLocation L)

## Protected Attributes
ArrayRef< Argument > | Args
| Word-like arguments. More...
ParagraphComment * | Paragraph
| Paragraph argument. More...
Protected Attributes inherited from clang::comments::Comment
SourceLocation | Loc
| Preferred location to show caret. More...
SourceRange | Range
| Source range of this AST node. More...
union {
CommentBitfields CommentBits
InlineContentCommentBitfields InlineContentCommentBits
TextCommentBitfields TextCommentBits
InlineCommandCommentBitfields InlineCommandCommentBits
HTMLTagCommentBitfields HTMLTagCommentBits
HTMLStartTagCommentBitfields HTMLStartTagCommentBits
ParagraphCommentBitfields ParagraphCommentBits
BlockCommandCommentBitfields BlockCommandCommentBits
ParamCommandCommentBitfields ParamCommandCommentBits
}; |

## Additional Inherited Members
Public Types inherited from clang::comments::Comment
enum | CommentKind { NoCommentKind = 0 }
typedef Comment *const * | child_iterator
Protected Types inherited from clang::comments::Comment
enum | { NumCommentBits = 8 }
enum | { NumInlineContentCommentBits = NumCommentBits + 1 }
enum | { NumTextCommentBits = NumInlineContentCommentBits + 2 }
enum | { NumInlineCommandCommentBits }
enum | { NumHTMLTagCommentBits = NumInlineContentCommentBits + 1 }
enum | { NumHTMLStartTagCommentBits = NumHTMLTagCommentBits + 1 }
enum | { NumParagraphCommentBits = NumCommentBits + 2 }
enum | { NumBlockCommandCommentBits }
enum | { NumParamCommandCommentBits = NumBlockCommandCommentBits + 3 }

## Detailed Description

A command that has zero or more word-like arguments (number of word-like arguments depends on command name) and a paragraph as an argument (e.

g., \brief).

Definition at line 597 of file Comment.h.

## Constructor & Destructor Documentation

## ◆ BlockCommandComment() [1/2]

clang::comments::BlockCommandComment::BlockCommandComment | ( | CommentKind | K,
|  | SourceLocation | LocBegin,
|  | SourceLocation | LocEnd,
|  | unsigned | CommandID,
|  | CommandMarkerKind | CommandMarker
| ) |  |
| inline protected

Definition at line 614 of file Comment.h.

References clang::comments::Comment::BlockCommandCommentBits, and clang::comments::Comment::setLocation().

## ◆ BlockCommandComment() [2/2]

clang::comments::BlockCommandComment::BlockCommandComment | ( | SourceLocation | LocBegin,
|  | SourceLocation | LocEnd,
|  | unsigned | CommandID,
|  | CommandMarkerKind | CommandMarker
| ) |  |
| inline

Definition at line 627 of file Comment.h.

References clang::comments::Comment::BlockCommandCommentBits, and clang::comments::Comment::setLocation().

## Member Function Documentation

## ◆ child_begin()

child_iterator clang::comments::BlockCommandComment::child_begin | ( |  | ) | const
| inline

Definition at line 643 of file Comment.h.

## ◆ child_end()

child_iterator clang::comments::BlockCommandComment::child_end | ( |  | ) | const
| inline

Definition at line 647 of file Comment.h.

## ◆ classof()

static bool clang::comments::BlockCommandComment::classof | ( | const Comment * | C | ) |
| inline static

Definition at line 638 of file Comment.h.

References clang::comments::Comment::getCommentKind().

## ◆ getArgRange()

SourceRange clang::comments::BlockCommandComment::getArgRange | ( | unsigned | Idx | ) | const
| inline

Definition at line 677 of file Comment.h.

Referenced by clang::comments::Sema::checkBlockCommandEmptyParagraph().

## ◆ getArgText()

StringRef clang::comments::BlockCommandComment::getArgText | ( | unsigned | Idx | ) | const
| inline

Definition at line 673 of file Comment.h.

Referenced by clang::TextNodeDumper::visitBlockCommandComment().

## ◆ getCommandID()

unsigned clang::comments::BlockCommandComment::getCommandID | ( |  | ) | const
| inline

Definition at line 651 of file Comment.h.

References clang::comments::Comment::BlockCommandCommentBits.

Referenced by clang::comments::Sema::checkBlockCommandDuplicate(), clang::comments::Sema::checkBlockCommandEmptyParagraph(), clang::comments::Sema::checkContainerDecl(), clang::comments::Sema::checkContainerDeclVerbatimLine(), clang::comments::Sema::checkDeprecatedCommand(), clang::comments::Sema::checkFunctionDeclVerbatimLine(), clang::comments::Sema::checkReturnsCommand(), clang::TextNodeDumper::visitBlockCommandComment(), and clang::TextNodeDumper::visitVerbatimBlockComment().

## ◆ getCommandMarker()

CommandMarkerKind clang::comments::BlockCommandComment::getCommandMarker | ( |  | ) | const
| inline

Definition at line 705 of file Comment.h.

References clang::comments::Comment::BlockCommandCommentBits.

Referenced by clang::comments::Sema::checkBlockCommandDuplicate(), clang::comments::Sema::checkBlockCommandEmptyParagraph(), clang::comments::Sema::checkContainerDecl(), clang::comments::Sema::checkContainerDeclVerbatimLine(), clang::comments::Sema::checkFunctionDeclVerbatimLine(), and clang::comments::Sema::checkReturnsCommand().

## ◆ getCommandName()

StringRef clang::comments::BlockCommandComment::getCommandName | ( | const CommandTraits & | Traits | ) | const
| inline

Definition at line 655 of file Comment.h.

References clang::comments::CommandTraits::getCommandInfo(), and clang::comments::CommandInfo::Name.

Referenced by clang::comments::Sema::checkBlockCommandDuplicate(), clang::comments::Sema::checkBlockCommandEmptyParagraph(), and clang::comments::Sema::checkReturnsCommand().

## ◆ getCommandNameBeginLoc()

SourceLocation clang::comments::BlockCommandComment::getCommandNameBeginLoc | ( |  | ) | const
| inline

Definition at line 659 of file Comment.h.

References clang::comments::Comment::getBeginLoc(), and clang::SourceLocation::getLocWithOffset().

## ◆ getCommandNameRange()

SourceRange clang::comments::BlockCommandComment::getCommandNameRange | ( | const CommandTraits & | Traits | ) | const
| inline

Definition at line 663 of file Comment.h.

Referenced by clang::comments::Sema::actOnParamCommandStart(), clang::comments::Sema::actOnTParamCommandStart(), and clang::comments::Sema::checkBlockCommandEmptyParagraph().

## ◆ getNumArgs()

unsigned clang::comments::BlockCommandComment::getNumArgs | ( |  | ) | const
| inline

Definition at line 669 of file Comment.h.

Referenced by clang::comments::Sema::actOnParamCommandParamNameArg(), clang::comments::Sema::actOnTParamCommandParamNameArg(), clang::comments::Sema::checkBlockCommandEmptyParagraph(), and clang::TextNodeDumper::visitBlockCommandComment().

## ◆ getParagraph()

ParagraphComment* clang::comments::BlockCommandComment::getParagraph | ( |  | ) | const
| inline

Definition at line 690 of file Comment.h.

Referenced by clang::comments::Sema::checkBlockCommandEmptyParagraph().

## ◆ hasNonWhitespaceParagraph()

bool clang::comments::BlockCommandComment::hasNonWhitespaceParagraph | ( |  | ) | const
| inline

Definition at line 694 of file Comment.h.

References clang::comments::ParagraphComment::isWhitespace().

## ◆ setArgs()

void clang::comments::BlockCommandComment::setArgs | ( | ArrayRef< Argument > | A | ) |
| inline

Definition at line 681 of file Comment.h.

References clang::comments::Comment::getBeginLoc(), clang::SourceLocation::isValid(), and clang::comments::Comment::setSourceRange().

Referenced by clang::comments::Sema::actOnBlockCommandArgs(), clang::comments::Sema::actOnParamCommandParamNameArg(), and clang::comments::Sema::actOnTParamCommandParamNameArg().

## ◆ setParagraph()

void clang::comments::BlockCommandComment::setParagraph | ( | ParagraphComment * | PC | ) |
| inline

Definition at line 698 of file Comment.h.

References clang::comments::Comment::getBeginLoc(), clang::comments::Comment::getEndLoc(), clang::SourceLocation::isValid(), and clang::comments::Comment::setSourceRange().

Referenced by clang::comments::Sema::actOnBlockCommandFinish(), clang::comments::Sema::actOnParamCommandFinish(), and clang::comments::Sema::actOnTParamCommandFinish().

## Member Data Documentation

## ◆ Args

ArrayRef<Argument> clang::comments::BlockCommandComment::Args
| protected

Word-like arguments.

Definition at line 609 of file Comment.h.

## ◆ Paragraph

ParagraphComment* clang::comments::BlockCommandComment::Paragraph
| protected

Paragraph argument.

Definition at line 612 of file Comment.h.

The documentation for this class was generated from the following file:

- include/clang/AST/Comment.h